*** dmenu.c	2012-01-08 14:18:43.000000000 +0200
--- dmenu-patchd.c	2012-06-19 22:58:02.826679154 +0300
***************
*** 60,65 ****
--- 60,66 ----
  static Item *prev, *curr, *next, *sel;
  static Window win;
  static XIC xic;
+ static Bool nout = False;
  
  static int (*fstrncmp)(const char *, const char *, size_t) = strncmp;
  static char *(*fstrstr)(const char *, const char *) = strstr;
***************
*** 83,88 ****
--- 84,91 ----
  			fstrncmp = strncasecmp;
  			fstrstr = cistrstr;
  		}
+ 		else if(!strcmp(argv[i], "-n"))  /* no output */
+ 			nout = True;
  		else if(i+1 == argc)
  			usage();
  		/* these options take one argument */
***************
*** 174,210 ****
  		drawtext(dc, prompt, selcol);
  		dc->x = dc->w;
  	}
! 	/* draw input field */
! 	dc->w = (lines > 0 || !matches) ? mw - dc->x : inputw;
! 	drawtext(dc, text, normcol);
! 	if((curpos = textnw(dc, text, cursor) + dc->h/2 - 2) < dc->w)
! 		drawrect(dc, curpos, 2, 1, dc->h - 4, True, FG(dc, normcol));
! 
! 	if(lines > 0) {
! 		/* draw vertical list */
! 		dc->w = mw - dc->x;
! 		for(item = curr; item != next; item = item->right) {
! 			dc->y += dc->h;
! 			drawtext(dc, item->text, (item == sel) ? selcol : normcol);
  		}
! 	}
! 	else if(matches) {
! 		/* draw horizontal list */
! 		dc->x += inputw;
! 		dc->w = textw(dc, "<");
! 		if(curr->left)
! 			drawtext(dc, "<", normcol);
! 		for(item = curr; item != next; item = item->right) {
! 			dc->x += dc->w;
! 			dc->w = MIN(textw(dc, item->text), mw - dc->x - textw(dc, ">"));
! 			drawtext(dc, item->text, (item == sel) ? selcol : normcol);
  		}
! 		dc->w = textw(dc, ">");
! 		dc->x = mw - dc->w;
! 		if(next)
! 			drawtext(dc, ">", normcol);
  	}
- 	mapdc(dc, win, mw, mh);
  }
  
  void
--- 177,215 ----
  		drawtext(dc, prompt, selcol);
  		dc->x = dc->w;
  	}
! 	if(!nout) {
! 		/* draw input field */
! 		dc->w = (lines > 0 || !matches) ? mw - dc->x : inputw;
! 		drawtext(dc, text, normcol);
! 		if((curpos = textnw(dc, text, cursor) + dc->h/2 - 2) < dc->w)
! 			drawrect(dc, curpos, 2, 1, dc->h - 4, True, FG(dc, normcol));
! 
! 		if(lines > 0) {
! 			/* draw vertical list */
! 			dc->w = mw - dc->x;
! 			for(item = curr; item != next; item = item->right) {
! 				dc->y += dc->h;
! 				drawtext(dc, item->text, (item == sel) ? selcol : normcol);
! 			}
  		}
! 		else if(matches) {
! 			/* draw horizontal list */
! 			dc->x += inputw;
! 			dc->w = textw(dc, "<");
! 			if(curr->left)
! 				drawtext(dc, "<", normcol);
! 			for(item = curr; item != next; item = item->right) {
! 				dc->x += dc->w;
! 				dc->w = MIN(textw(dc, item->text), mw - dc->x - textw(dc, ">"));
! 				drawtext(dc, item->text, (item == sel) ? selcol : normcol);
! 			}
! 			dc->w = textw(dc, ">");
! 			dc->x = mw - dc->w;
! 			if(next)
! 				drawtext(dc, ">", normcol);
  		}
! 		mapdc(dc, win, mw, mh);
  	}
  }
  
  void
